#ifndef __BILATERAL_DIALOGIMPL_H_
#define __BILATERAL_DIALOGIMPL_H_

#include <qwidget.h>

#include "../../../Core/Scene/src/Object.h"
#include "../../../Core/DataStructures/src/NeighbourHood.h"
#include "../../../Core/DataStructures/src/AdjacencyGraph.h"


#include "../UI/Bilateral_Dialog.h"

/**
 *
 * @author Matthias Zwicker
 * @version 1.2
 */
class Bilateral_DialogImpl : public Bilateral_Dialog {
	
    Q_OBJECT

public:

	/**
	 * This method creates an instance of this <code>Bilateral_DialogImpl</code>, if necessary,
	 * and returns it. Only one instance at a time exists (singleton pattern).
	 *
	 * @return an instance of this <code>Bilateral_DialogImpl</code>
	 */
	static Bilateral_DialogImpl *getInstance();

	/**
	 * Destroys the instance of this <code>Bilateral_DialogImpl</code>, if there
	 * is one.
	 */
	static void destroyInstance();
	
private:
	Bilateral_DialogImpl (QWidget *parent = 0, const char *name = 0, bool modal = false, WFlags flags = 0);


protected:  // To suppress warnings...
	virtual ~Bilateral_DialogImpl();

private:
	// initialises this dialog, setting all text labels, connects the signals
	void initDialog();

	float defSpatialWidth;
	float defInfluenceWidth;

private slots:
	void handlePointFiltering();
	void handleNormalFiltering();
};

#endif  // __BILATERAL_DIALOGIMPL_H_
