#include <qobject.h>

#include "../../../Core/Scene/src/Scene.h"
#include "Bilateral_Plugin.h"
#include "Bilateral_DialogImpl.h"


// ******************
// 'What's this' text
// ******************

static const char *whatsThisText = "Bilateral Filter"
"<ul><li>Use this plugin to perform robust, feature</li>"
"<li>preserving smoothing of point sampled surfaces </li>"
"<li>with the bilateral filter</li></ul>";

// **************
// public methods
// **************

Bilateral_Plugin::Bilateral_Plugin() {}
Bilateral_Plugin::~Bilateral_Plugin() {}

void Bilateral_Plugin::execute() {

	Bilateral_DialogImpl *bilateral_Dialog;
	
	bilateral_Dialog = Bilateral_DialogImpl::getInstance();
	bilateral_Dialog->show();
	bilateral_Dialog->raise();

}

bool Bilateral_Plugin::isAvailable() const {
	return true; 
// mz: this makes the pointshop crash... no clue why.
//	return this->checkPluginAvailability();
}

// ***************
// private methods
// ***************

bool Bilateral_Plugin::checkPluginAvailability() const {
	return (Scene::getInstance()->getNofObjects() > 0);
}

// ****************
// access functions
// ****************

PLUGIN_API PluginInterface *createPlugin() {
	return new Bilateral_Plugin();
}

PLUGIN_API const char *getPluginName() {
	// TODO: return a plugin name here which is to appear in the plugin menu
	return "Bilateral Filtering ...";
}

PLUGIN_API const char *getPluginDescription() {
	return whatsThisText;
}

